Public Class UserControl1

    Private ROW_COUNT As UShort = 40
    Private COL_COUNT As UShort = 12
    Private DSP_COL_COUNT As UShort = 5

    Private m_lstAnaSpd As List(Of FarPoint.Win.Spread.FpSpread)
    Private m_SpdHeight As Integer
    Private m_SpdWidth As Integer

    Public Sub New()

        InitializeComponent()

        Me.m_lstAnaSpd = New List(Of FarPoint.Win.Spread.FpSpread)

    End Sub

    Private Sub hsSpd_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles hsSpd.Scroll

        Me.pnlSpd.Left = -Me.hsSpd.Value * SpdSize.Width

    End Sub

    Private Sub hsSpdCol_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles hsSpdCol.Scroll

        For Each ctrlSpd As Control In Me.pnlSpd.Controls
            CType(ctrlSpd, FarPoint.Win.Spread.FpSpread).SetViewportLeftColumn(0, 2 + Me.hsSpdCol.Value)
        Next

    End Sub

    Private Sub vsSpdRow_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles vsSpdRow.Scroll

        For Each ctrlSpd As Control In Me.pnlSpd.Controls
            CType(ctrlSpd, FarPoint.Win.Spread.FpSpread).SetViewportTopRow(0, Me.vsSpdRow.Value + 1)
        Next

    End Sub

    Public Property SpdSize() As Size

        Get
            Return New Size(m_SpdWidth, m_SpdHeight)
        End Get
        Set(ByVal value As Size)
            m_SpdHeight = value.Height
            m_SpdWidth = value.Width
        End Set

    End Property

    Public Sub AddSpread(ByVal intElmCount As Integer)

        Call Me.pvSetSize()

        For Each ctrlSpd As Control In Me.Controls
            If TypeOf ctrlSpd Is FarPoint.Win.Spread.FpSpread Then
                Me.Controls.Remove(ctrlSpd)
            End If
        Next

        If intElmCount = 0 Then
            Exit Sub
        End If

        Dim intSpdCount As UShort
        If intElmCount <= ROW_COUNT Then
            intSpdCount = 1
        Else
            intSpdCount = CUShort(Math.Ceiling(intElmCount / ROW_COUNT))
        End If

        Dim spdAnlSpd As FarPoint.Win.Spread.FpSpread = Nothing
        For i As Integer = 0 To intSpdCount - 1
            pvGetSpd(spdAnlSpd)
            spdAnlSpd.Location = pvSetLocation()
            spdAnlSpd.TabIndex = i
            m_lstAnaSpd.Add(spdAnlSpd)
            Me.pnlSpd.Controls.Add(spdAnlSpd)
        Next

        Me.hsSpd.Maximum = m_lstAnaSpd.Count - 1
        Me.hsSpd.LargeChange = 1
        Me.hsSpd.SmallChange = 1


        Me.hsSpdCol.Maximum = COL_COUNT - 2 - DSP_COL_COUNT
        Me.hsSpdCol.LargeChange = 1
        Me.hsSpdCol.SmallChange = 1

        If CInt(Me.Height / 20) < 20 * ROW_COUNT Then
            Me.vsSpdRow.Maximum = (20 * ROW_COUNT - Me.Height) / 20
            Me.vsSpdRow.LargeChange = 1
            Me.vsSpdRow.SmallChange = 1
        End If

    End Sub

    Private Sub pvSetSize()

        SpdSize = New Size(80 * (DSP_COL_COUNT + 2), 20 * (ROW_COUNT + 1))

    End Sub

    Private Function pvSetLocation() As Point

        If m_lstAnaSpd Is Nothing Then
            Return New Point(0, 0)
        Else
            Return New Point(SpdSize.Width * m_lstAnaSpd.Count, 0)
        End If


    End Function

    Private Sub pvGetSpd(ByRef spdAnlSpd As FarPoint.Win.Spread.FpSpread)

        Dim FpSpread1 As FarPoint.Win.Spread.FpSpread
        Dim FpSpread1_Sheet1 As FarPoint.Win.Spread.SheetView

        FpSpread1 = New FarPoint.Win.Spread.FpSpread
        FpSpread1_Sheet1 = New FarPoint.Win.Spread.SheetView
        spdAnlSpd = FpSpread1
        FpSpread1_Sheet1.FrozenColumnCount = 2
        CType(FpSpread1, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(FpSpread1_Sheet1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()

        '
        'FpSpread1
        '
        FpSpread1.About = "3.0.2006.2005"
        FpSpread1.AccessibleDescription = "FpSpread1, Sheet1, Row 0, Column 0, "
        FpSpread1.BackColor = System.Drawing.SystemColors.Control
        FpSpread1.Font = New System.Drawing.Font("lr SVbN", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(128, Byte))
        FpSpread1.HorizontalScrollBarPolicy = FarPoint.Win.Spread.ScrollBarPolicy.Never
        ' '' '' '' ''FpSpread1.Location = New System.Drawing.Point(59, 55)
        FpSpread1.Name = "FpSpread1"
        FpSpread1.RightToLeft = System.Windows.Forms.RightToLeft.No
        FpSpread1.Sheets.AddRange(New FarPoint.Win.Spread.SheetView() {FpSpread1_Sheet1})
        FpSpread1.Size = SpdSize
        FpSpread1.TabIndex = 0
        FpSpread1.VerticalScrollBarPolicy = FarPoint.Win.Spread.ScrollBarPolicy.Never

        '
        'FpSpread1_Sheet1
        '
        FpSpread1_Sheet1.Reset()
        FpSpread1_Sheet1.SheetName = "Sheet1"
        'Formulas and custom names must be loaded with R1C1 reference style
        FpSpread1_Sheet1.ReferenceStyle = FarPoint.Win.Spread.Model.ReferenceStyle.R1C1
        FpSpread1_Sheet1.ColumnCount = COL_COUNT
        FpSpread1_Sheet1.RowCount = ROW_COUNT
        FpSpread1_Sheet1.ColumnHeader.AutoText = FarPoint.Win.Spread.HeaderAutoText.Blank
        FpSpread1_Sheet1.Columns.Get(0).CellType = New FarPoint.Win.Spread.CellType.TextCellType
        FpSpread1_Sheet1.Columns.Get(0).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Left
        FpSpread1_Sheet1.Columns.Get(0).Resizable = False
        FpSpread1_Sheet1.Columns.Get(0).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center

        For i As Integer = 0 To FpSpread1.ActiveSheet.Columns.Count - 1
            FpSpread1_Sheet1.Columns.Get(i).CellType = New FarPoint.Win.Spread.CellType.TextCellType
            FpSpread1_Sheet1.Columns.Get(i).HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Right
            FpSpread1_Sheet1.Columns.Get(i).Resizable = False
            FpSpread1_Sheet1.Columns.Get(i).VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center
        Next

        FpSpread1_Sheet1.PrintInfo.ZoomFactor = 1.0!
        FpSpread1_Sheet1.RowHeader.AutoText = FarPoint.Win.Spread.HeaderAutoText.Blank
        FpSpread1_Sheet1.RowHeader.Columns.Default.Resizable = False
        FpSpread1_Sheet1.RowHeader.Visible = False
        FpSpread1_Sheet1.ReferenceStyle = FarPoint.Win.Spread.Model.ReferenceStyle.A1

        Me.Controls.Add(FpSpread1)
        CType(FpSpread1, System.ComponentModel.ISupportInitialize).EndInit()
        CType(FpSpread1_Sheet1, System.ComponentModel.ISupportInitialize).EndInit()

        Me.ResumeLayout(False)

    End Sub

End Class
